diff -dcrpN postgresql.orig/src/include/catalog/pg_statistic.h postgresql/src/include/catalog/pg_statistic.h
*** postgresql.orig/src/include/catalog/pg_statistic.h	2011-02-22 18:51:42.762512469 +0100
--- postgresql/src/include/catalog/pg_statistic.h	2011-09-12 10:01:16.877492756 +0200
***************
*** 40,50 ****
  
  CATALOG(pg_statistic,2619) BKI_WITHOUT_OIDS
  {
! 	/* These fields form the unique key for the entry: */
  	Oid			starelid;		/* relation containing attribute */
- 	int2		staattnum;		/* attribute (column) stats are for */
  	bool		stainherit;		/* true if inheritance children are included */
  
  	/* the fraction of the column's entries that are NULL: */
  	float4		stanullfrac;
  
--- 40,63 ----
  
  CATALOG(pg_statistic,2619) BKI_WITHOUT_OIDS
  {
! 	/*
! 	 * These fields (together with the staattnums field below in the variable fields)
! 	 * form the unique key for the entry:
! 	 */
  	Oid			starelid;		/* relation containing attribute */
  	bool		stainherit;		/* true if inheritance children are included */
  
+ 	/* this entry is valid */
+ 	bool		stavalid;
+ 
+ 	/* statarget is the target number of statistics datapoints to collect
+ 	 * during VACUUM ANALYZE of this column.  A zero here indicates that we do
+ 	 * not wish to collect any stats about this column. A "-1" here indicates
+ 	 * that no value has been explicitly set for this column, so ANALYZE
+ 	 * should use the default setting.
+ 	 */
+ 	int4		statarget;
+ 
  	/* the fraction of the column's entries that are NULL: */
  	float4		stanullfrac;
  
*************** CATALOG(pg_statistic,2619) BKI_WITHOUT_O
*** 110,115 ****
--- 123,129 ----
  	 * the full field access machinery (heap_getattr) for them.  We declare
  	 * them here for the catalog machinery.
  	 */
+ 	int2vector		staattnums;		/* attributes (columns) stats are for */
  
  	float4		stanumbers1[1];
  	float4		stanumbers2[1];
*************** typedef FormData_pg_statistic *Form_pg_s
*** 143,171 ****
   *		compiler constants for pg_statistic
   * ----------------
   */
! #define Natts_pg_statistic				22
  #define Anum_pg_statistic_starelid		1
! #define Anum_pg_statistic_staattnum		2
! #define Anum_pg_statistic_stainherit	3
! #define Anum_pg_statistic_stanullfrac	4
! #define Anum_pg_statistic_stawidth		5
! #define Anum_pg_statistic_stadistinct	6
! #define Anum_pg_statistic_stakind1		7
! #define Anum_pg_statistic_stakind2		8
! #define Anum_pg_statistic_stakind3		9
! #define Anum_pg_statistic_stakind4		10
! #define Anum_pg_statistic_staop1		11
! #define Anum_pg_statistic_staop2		12
! #define Anum_pg_statistic_staop3		13
! #define Anum_pg_statistic_staop4		14
! #define Anum_pg_statistic_stanumbers1	15
! #define Anum_pg_statistic_stanumbers2	16
! #define Anum_pg_statistic_stanumbers3	17
! #define Anum_pg_statistic_stanumbers4	18
! #define Anum_pg_statistic_stavalues1	19
! #define Anum_pg_statistic_stavalues2	20
! #define Anum_pg_statistic_stavalues3	21
! #define Anum_pg_statistic_stavalues4	22
  
  /*
   * Currently, three statistical slot "kinds" are defined: most common values,
--- 157,187 ----
   *		compiler constants for pg_statistic
   * ----------------
   */
! #define Natts_pg_statistic				24
  #define Anum_pg_statistic_starelid		1
! #define Anum_pg_statistic_stainherit		2
! #define Anum_pg_statistic_stavalid		3
! #define Anum_pg_statistic_statarget		4
! #define Anum_pg_statistic_stanullfrac		5
! #define Anum_pg_statistic_stawidth		6
! #define Anum_pg_statistic_stadistinct		7
! #define Anum_pg_statistic_stakind1		8
! #define Anum_pg_statistic_stakind2		9
! #define Anum_pg_statistic_stakind3		10
! #define Anum_pg_statistic_stakind4		11
! #define Anum_pg_statistic_staop1		12
! #define Anum_pg_statistic_staop2		13
! #define Anum_pg_statistic_staop3		14
! #define Anum_pg_statistic_staop4		15
! #define Anum_pg_statistic_staattnums		16
! #define Anum_pg_statistic_stanumbers1	17
! #define Anum_pg_statistic_stanumbers2	18
! #define Anum_pg_statistic_stanumbers3	19
! #define Anum_pg_statistic_stanumbers4	20
! #define Anum_pg_statistic_stavalues1	21
! #define Anum_pg_statistic_stavalues2	22
! #define Anum_pg_statistic_stavalues3	23
! #define Anum_pg_statistic_stavalues4	24
  
  /*
   * Currently, three statistical slot "kinds" are defined: most common values,
diff -dcrpN postgresql.orig/src/include/commands/defrem.h postgresql/src/include/commands/defrem.h
*** postgresql.orig/src/include/commands/defrem.h	2011-07-24 18:16:45.287677928 +0200
--- postgresql/src/include/commands/defrem.h	2011-09-12 10:01:16.899491728 +0200
*************** extern void RemoveAggregate(RemoveFuncSt
*** 93,98 ****
--- 93,101 ----
  extern void RenameAggregate(List *name, List *args, const char *newname);
  extern void AlterAggregateOwner(List *name, List *args, Oid newOwnerId);
  
+ /* commands/analyze.c */
+ extern void ExtraStatistics(ExtraStatStmt *stmt);
+ 
  /* commands/opclasscmds.c */
  extern void DefineOpClass(CreateOpClassStmt *stmt);
  extern void DefineOpFamily(CreateOpFamilyStmt *stmt);
diff -dcrpN postgresql.orig/src/include/commands/vacuum.h postgresql/src/include/commands/vacuum.h
*** postgresql.orig/src/include/commands/vacuum.h	2011-06-02 10:21:24.006634564 +0200
--- postgresql/src/include/commands/vacuum.h	2011-09-12 10:01:16.912491121 +0200
***************
*** 56,67 ****
   * This might change in some future release.
   *----------
   */
! typedef struct VacAttrStats *VacAttrStatsP;
  
! typedef Datum (*AnalyzeAttrFetchFunc) (VacAttrStatsP stats, int rownum,
  												   bool *isNull);
  
! typedef struct VacAttrStats
  {
  	/*
  	 * These fields are set up by the main ANALYZE code before invoking the
--- 56,84 ----
   * This might change in some future release.
   *----------
   */
! typedef struct VacStats *VacStatsP;
  
! typedef Datum (*AnalyzeAttrFetchFunc) (VacStatsP stats, int rownum, AttrNumber tupattnum,
  												   bool *isNull);
  
! typedef void (*ComputeStatsFunc) (VacStatsP stats,
! 												   int index,
! 												   AnalyzeAttrFetchFunc fetchfunc,
! 												   int samplerows,
! 												   double totalrows);
! 
! typedef int (*FindValueIndex) (VacStatsP stats,
! 												   int rownum,
! 												   int index,
! 												   AnalyzeAttrFetchFunc fetchfunc,
! 												   void *arg);
! 
! typedef struct StatsFuncStruct {
! 	ComputeStatsFunc	compute_func_ptr;
! 	FindValueIndex		findval_func_ptr;
! } StatsFuncStruct;
! 
! typedef struct VacStats
  {
  	/*
  	 * These fields are set up by the main ANALYZE code before invoking the
*************** typedef struct VacAttrStats
*** 73,109 ****
  	 * column/expression.  Instead use attrtypid, attrtypmod, and attrtype for
  	 * information about the datatype being fed to the typanalyze function.
  	 */
! 	Form_pg_attribute attr;		/* copy of pg_attribute row for column */
! 	Oid			attrtypid;		/* type of data being analyzed */
! 	int32		attrtypmod;		/* typmod of data being analyzed */
! 	Form_pg_type attrtype;		/* copy of pg_type row for attrtypid */
  	MemoryContext anl_context;	/* where to save long-lived data */
  
  	/*
  	 * These fields must be filled in by the typanalyze routine, unless it
  	 * returns FALSE.
  	 */
! 	void		(*compute_stats) (VacAttrStatsP stats,
! 											  AnalyzeAttrFetchFunc fetchfunc,
! 											  int samplerows,
! 											  double totalrows);
  	int			minrows;		/* Minimum # of rows wanted for stats */
! 	void	   *extra_data;		/* for extra type-specific data */
  
  	/*
  	 * These fields are to be filled in by the compute_stats routine. (They
  	 * are initialized to zero when the struct is created.)
  	 */
  	bool		stats_valid;
! 	float4		stanullfrac;	/* fraction of entries that are NULL */
! 	int4		stawidth;		/* average width of column values */
! 	float4		stadistinct;	/* # distinct values */
! 	int2		stakind[STATISTIC_NUM_SLOTS];
! 	Oid			staop[STATISTIC_NUM_SLOTS];
! 	int			numnumbers[STATISTIC_NUM_SLOTS];
! 	float4	   *stanumbers[STATISTIC_NUM_SLOTS];
! 	int			numvalues[STATISTIC_NUM_SLOTS];
! 	Datum	   *stavalues[STATISTIC_NUM_SLOTS];
  
  	/*
  	 * These fields describe the stavalues[n] element types. They will be
--- 90,126 ----
  	 * column/expression.  Instead use attrtypid, attrtypmod, and attrtype for
  	 * information about the datatype being fed to the typanalyze function.
  	 */
! 	Form_pg_attribute attrs[STATISTIC_NUM_SLOTS];	/* copy of pg_attribute row for column */
! 	int2vector *attnums;		/* array of attributes this statistics is for */
! 	int4		statarget;	/* effective statistics target */
! 	Oid			attrtypids[STATISTIC_NUM_SLOTS];	/* type of data being analyzed */
! 	int32		attrtypmods[STATISTIC_NUM_SLOTS];		/* typmod of data being analyzed */
! 	Form_pg_type attrtypes[STATISTIC_NUM_SLOTS];			/* copy of pg_type row for attrtypid */
  	MemoryContext anl_context;	/* where to save long-lived data */
  
  	/*
  	 * These fields must be filled in by the typanalyze routine, unless it
  	 * returns FALSE.
  	 */
! 
! 	StatsFuncStruct		statfuncs[STATISTIC_NUM_SLOTS];
  	int			minrows;		/* Minimum # of rows wanted for stats */
! 	void	   *extra_data[STATISTIC_NUM_SLOTS];	/* for extra type-specific data */
  
  	/*
  	 * These fields are to be filled in by the compute_stats routine. (They
  	 * are initialized to zero when the struct is created.)
  	 */
  	bool		stats_valid;
! 	float4		stanullfrac[STATISTIC_NUM_SLOTS];	/* fraction of entries that are NULL */
! 	int4		stawidth[STATISTIC_NUM_SLOTS];		/* average width of column values */
! 	float4		stadistinct[STATISTIC_NUM_SLOTS];	/* # distinct values */
! 	int2		stakind[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	Oid			staop[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	int			numnumbers[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	float4	   *stanumbers[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	int			numvalues[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	Datum	   *stavalues[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
  
  	/*
  	 * These fields describe the stavalues[n] element types. They will be
*************** typedef struct VacAttrStats
*** 111,132 ****
  	 * want to store an array of something other than the analyzed column's
  	 * elements. It should then overwrite these fields.
  	 */
! 	Oid			statypid[STATISTIC_NUM_SLOTS];
! 	int2		statyplen[STATISTIC_NUM_SLOTS];
! 	bool		statypbyval[STATISTIC_NUM_SLOTS];
! 	char		statypalign[STATISTIC_NUM_SLOTS];
  
  	/*
  	 * These fields are private to the main ANALYZE code and should not be
  	 * looked at by type-specific functions.
  	 */
- 	int			tupattnum;		/* attribute number within tuples */
  	HeapTuple  *rows;			/* access info for std fetch function */
  	TupleDesc	tupDesc;
  	Datum	   *exprvals;		/* access info for index fetch function */
  	bool	   *exprnulls;
  	int			rowstride;
! } VacAttrStats;
  
  
  /* GUC parameters */
--- 128,148 ----
  	 * want to store an array of something other than the analyzed column's
  	 * elements. It should then overwrite these fields.
  	 */
! 	Oid			statypid[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	int2		statyplen[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	bool		statypbyval[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
! 	char		statypalign[STATISTIC_NUM_SLOTS][STATISTIC_NUM_SLOTS];
  
  	/*
  	 * These fields are private to the main ANALYZE code and should not be
  	 * looked at by type-specific functions.
  	 */
  	HeapTuple  *rows;			/* access info for std fetch function */
  	TupleDesc	tupDesc;
  	Datum	   *exprvals;		/* access info for index fetch function */
  	bool	   *exprnulls;
  	int			rowstride;
! } VacStats;
  
  
  /* GUC parameters */
diff -dcrpN postgresql.orig/src/include/nodes/nodes.h postgresql/src/include/nodes/nodes.h
*** postgresql.orig/src/include/nodes/nodes.h	2011-08-07 11:29:16.032255410 +0200
--- postgresql/src/include/nodes/nodes.h	2011-09-12 10:01:16.929490327 +0200
*************** typedef enum NodeTag
*** 362,367 ****
--- 362,368 ----
  	T_CreateExtensionStmt,
  	T_AlterExtensionStmt,
  	T_AlterExtensionContentsStmt,
+ 	T_ExtraStatStmt,
  
  	/*
  	 * TAGS FOR PARSE TREE NODES (parsenodes.h)
diff -dcrpN postgresql.orig/src/include/nodes/parsenodes.h postgresql/src/include/nodes/parsenodes.h
*** postgresql.orig/src/include/nodes/parsenodes.h	2011-08-07 11:29:16.033255357 +0200
--- postgresql/src/include/nodes/parsenodes.h	2011-09-12 10:01:16.939489863 +0200
*************** typedef enum DropBehavior
*** 1161,1166 ****
--- 1161,1180 ----
  } DropBehavior;
  
  /* ----------------------
+  *     Create Cross Column Statistics
+  * ----------------------
+  */
+ typedef struct ExtraStatStmt
+ {
+ 	NodeTag		type;
+ 	char		relkind;
+ 	bool		create;
+ 	RangeVar   *relation;
+ 	List	   *columns;
+ 	int		statistics_target;
+ } ExtraStatStmt;
+ 
+ /* ----------------------
   *	Alter Table
   * ----------------------
   */
diff -dcrpN postgresql.orig/src/include/parser/parse_utilcmd.h postgresql/src/include/parser/parse_utilcmd.h
*** postgresql.orig/src/include/parser/parse_utilcmd.h	2011-01-04 15:13:16.163549374 +0100
--- postgresql/src/include/parser/parse_utilcmd.h	2011-09-12 10:01:16.953489208 +0200
*************** extern void transformRuleStmt(RuleStmt *
*** 25,28 ****
--- 25,31 ----
  				  List **actions, Node **whereClause);
  extern List *transformCreateSchemaStmt(CreateSchemaStmt *stmt);
  
+ extern ExtraStatStmt *transformExtraStatistics(ExtraStatStmt *stmt,
+ 						const char *queryString);
+ 
  #endif   /* PARSE_UTILCMD_H */
diff -dcrpN postgresql.orig/src/include/utils/builtins.h postgresql/src/include/utils/builtins.h
*** postgresql.orig/src/include/utils/builtins.h	2011-06-24 11:38:23.342905815 +0200
--- postgresql/src/include/utils/builtins.h	2011-09-12 10:01:16.963488738 +0200
*************** extern Datum int2vectorout(PG_FUNCTION_A
*** 174,179 ****
--- 174,184 ----
  extern Datum int2vectorrecv(PG_FUNCTION_ARGS);
  extern Datum int2vectorsend(PG_FUNCTION_ARGS);
  extern Datum int2vectoreq(PG_FUNCTION_ARGS);
+ extern Datum int2vectorne(PG_FUNCTION_ARGS);
+ extern Datum int2vectorlt(PG_FUNCTION_ARGS);
+ extern Datum int2vectorle(PG_FUNCTION_ARGS);
+ extern Datum int2vectorgt(PG_FUNCTION_ARGS);
+ extern Datum int2vectorge(PG_FUNCTION_ARGS);
  extern Datum int4in(PG_FUNCTION_ARGS);
  extern Datum int4out(PG_FUNCTION_ARGS);
  extern Datum int4recv(PG_FUNCTION_ARGS);
*************** extern void pg_lltoa(int64 ll, char *a);
*** 283,288 ****
--- 288,294 ----
   */
  extern Datum btboolcmp(PG_FUNCTION_ARGS);
  extern Datum btint2cmp(PG_FUNCTION_ARGS);
+ extern Datum btint2vectorcmp(PG_FUNCTION_ARGS);
  extern Datum btint4cmp(PG_FUNCTION_ARGS);
  extern Datum btint8cmp(PG_FUNCTION_ARGS);
  extern Datum btfloat4cmp(PG_FUNCTION_ARGS);
diff -dcrpN postgresql.orig/src/include/utils/selfuncs.h postgresql/src/include/utils/selfuncs.h
*** postgresql.orig/src/include/utils/selfuncs.h	2011-09-05 15:08:06.539565424 +0200
--- postgresql/src/include/utils/selfuncs.h	2011-09-12 10:01:16.988487572 +0200
*************** typedef bool (*get_index_stats_hook_type
*** 110,115 ****
--- 110,119 ----
  												  VariableStatData *vardata);
  extern PGDLLIMPORT get_index_stats_hook_type get_index_stats_hook;
  
+ extern void validate_statistics(VariableStatData *vardata,
+ 						 Oid relid,
+ 						 AttrNumber *attnums, int n_attnums,
+ 						 bool inherited);
  extern void examine_variable(PlannerInfo *root, Node *node, int varRelid,
  				 VariableStatData *vardata);
  extern bool get_restriction_variable(PlannerInfo *root, List *args,
diff -dcrpN postgresql.orig/src/test/regress/sql/type_sanity.sql postgresql/src/test/regress/sql/type_sanity.sql
*** postgresql.orig/src/test/regress/sql/type_sanity.sql	2011-01-04 15:13:16.220546441 +0100
--- postgresql/src/test/regress/sql/type_sanity.sql	2011-09-12 10:01:17.029485654 +0200
*************** WHERE p1.typarray = p2.oid AND NOT (p1.t
*** 207,214 ****
  SELECT p1.oid, p1.typname, p2.oid, p2.proname
  FROM pg_type AS p1, pg_proc AS p2
  WHERE p1.typanalyze = p2.oid AND p1.typtype in ('b', 'p') AND NOT
!     (p2.pronargs = 1 AND
       p2.proargtypes[0] = 'internal'::regtype AND
       p2.prorettype = 'bool'::regtype AND NOT p2.proretset);
  
  -- **************** pg_class ****************
--- 207,215 ----
  SELECT p1.oid, p1.typname, p2.oid, p2.proname
  FROM pg_type AS p1, pg_proc AS p2
  WHERE p1.typanalyze = p2.oid AND p1.typtype in ('b', 'p') AND NOT
!     (p2.pronargs = 2 AND
       p2.proargtypes[0] = 'internal'::regtype AND
+      p2.proargtypes[1] = 'int4'::regtype AND
       p2.prorettype = 'bool'::regtype AND NOT p2.proretset);
  
  -- **************** pg_class ****************
